!!
 !   " OpenMP"
 !  ,  2011
 !
 ! http://kremer.pro/blog/?post_type=post&p=26
 !
 ! $ gfortran -fopenmp Recursion_EasyOMP.f90
 ! $ ./a.out
 !!

program Sequence_EasyOMP
	include "omp_lib.h"

	integer n
	double precision, dimension(:), allocatable :: A, S, nums, denoms
	double precision rnd, rnd_a, rnd_b
	double precision t1, t2
	integer i, j, pid

	do while (.TRUE.)
		write(*, "(A)", advance="no"), "N: "
		read *, n
		if (n < 1) then
			print *
			print *, "BAD VALUE"
			print *
		else
			exit
		endif
	enddo

!	print *
!	print *, "RANDOM PARAMETERS: A*rnd + B"
!	print *
!	write(*, "(A)", advance="no"), "A: "
!	read *, rnd_a
!	write(*, "(A)", advance="no"), "B: "
!	read *, rnd_b
	rnd_a = 1.0; rnd_b = 0.5429

	allocate(A(n))
	allocate(S(n))
	allocate(nums(n))
	allocate(denoms(n))

	do i = 1, n
		call random_number(rnd)
		A(i) = rnd * rnd_a + rnd_b
	enddo

	t1 = omp_get_wtime()
	nums(1) = A(1); denoms(1) = A(1)
	call omp_set_num_threads(2)
!$omp parallel private(pid) shared(nums, denoms, A)
	pid = omp_get_thread_num()
	if (pid == 0) then
		do i = 2, n
			nums(i) = nums(i - 1) * A(i)
		enddo
	else
		do i = 2, n
			denoms(i) = denoms(i - 1) + A(i)
		enddo
	endif
!$omp end parallel

!$omp parallel num_threads(8) shared(denoms, nums, S, n)
!$omp do
	do i = 1, n
		S(i) = nums(i)/denoms(i)
	enddo
!$omp end parallel
	t2 = omp_get_wtime()

	do i = 1, n
		print *, S(i)
	enddo
	deallocate(S, A, nums, denoms)

	print *, "USING EASY OMP:", t2 - t1
	!2.000.000: 0.31 -- 0.34
endprogram