!!
 !   " OpenMP"
 !  ,  2011
 !
 ! http://kremer.pro/blog/?post_type=post&p=26
 !
 ! $ gfortran -fopenmp Recursion_HardOMP.f90
 ! $ ./a.out
 !!

program Sequence_HardOMP
	include "omp_lib.h"

	integer n
	double precision, dimension(:), allocatable :: A, S, nums, denoms
	double precision, dimension(:), allocatable :: tn, td
	double precision rnd, rnd_a, rnd_b
	double precision t1, t2
	integer i, j, pid

	do while (.TRUE.)
		write(*, "(A)", advance="no"), "N: "
		read *, n
		if (n < 1) then
			print *
			print *, "BAD VALUE"
			print *
		else
			exit
		endif
	enddo

!	print *
!	print *, "RANDOM PARAMETERS: A*rnd + B"
!	print *
!	write(*, "(A)", advance="no"), "A: "
!	read *, rnd_a
!	write(*, "(A)", advance="no"), "B: "
!	read *, rnd_b
	rnd_a = 1.0; rnd_b = 0.5429

	allocate(A(n))
	allocate(S(n))
	allocate(nums(n))
	allocate(denoms(n))
	allocate(tn(n - 1))
	allocate(td(n - 1))

	do i = 1, n
		call random_number(rnd)
		A(i) = rnd * rnd_a + rnd_b
	enddo

	call omp_set_num_threads(4)
	t1 = omp_get_wtime()
!$omp parallel private(pid) shared(A, td, tn, nums, denoms)
!$omp do schedule(dynamic, 100)
	do i = 1, n - 1
		tn(i) = A(i) * A(i + 1)
		td(i) = A(i) + A(i + 1)
	enddo
!$omp barrier
	pid = omp_get_thread_num()
	if (pid == 0) then
		nums(1) = A(1)
		do i = 3, n, 2
			nums(i) = nums(i - 2) * tn(i - 1)
		enddo
	else if (pid == 1) then
		denoms(1) = A(1)
		do i = 3, n, 2
			denoms(i) = denoms(i - 2) + td(i - 1)
		enddo
	else if (pid == 2) then
		nums(2) = tn(1)
		do i = 4, n, 2
			nums(i) = nums(i - 2) * tn(i - 1)
		enddo
	else if (pid == 3) then
		denoms(2) = td(1)
		do i = 4, n, 2
			denoms(i) = denoms(i - 2) + td(i - 1)
		enddo
	endif
!$omp end parallel
	call omp_set_num_threads(8)
!$omp parallel private(i) shared(nums, denoms, S)
!$omp do schedule(dynamic, 100)
	do i = 1, n
		S(i) = nums(i)/denoms(i)
	enddo
!$omp end parallel
	t2 = omp_get_wtime()

	do i = 1, n
		print *, S(i)
	enddo
	deallocate(S, A, nums, denoms, tn, td)

	print *, "USING HARD OMP:", t2 - t1
	!2.000.000: 0.24 -- 0.27
end program
