!!
 !   " OpenMP"
 !  ,  2011
 !
 ! http://kremer.pro/blog/?post_type=post&p=26
 !
 ! $ gfortran -fopenmp Recursion_Linear.f90
 ! $ ./a.out
 !!

program Sequence_Linear
	include "omp_lib.h"

	integer n
	double precision, dimension(:), allocatable :: A, S
	double precision rnd, rnd_a, rnd_b
	double precision t1, t2
	double precision Sn, Sd
	integer i, j

	do while (.TRUE.)
		write(*, "(A)", advance="no"), "N: "
		read *, n
		if (n < 1) then
			print *
			print *, "BAD VALUE"
			print *
		else
			exit
		endif
	enddo

!	print *
!	print *, "RANDOM PARAMETERS: A*rnd + B"
!	print *
!	write(*, "(A)", advance="no"), "A: "
!	read *, rnd_a
!	write(*, "(A)", advance="no"), "B: "
!	read *, rnd_b
	rnd_a = 1.0; rnd_b = 0.5429

	allocate(A(n))
	allocate(S(n))

	do i = 1, n
		call random_number(rnd)
		A(i) = rnd * rnd_a + rnd_b
	enddo

	t1 = omp_get_wtime()
	Sn = A(1); Sd = A(1)
	S(1) = 1
	do i = 2, n
		Sn = Sn * A(i)
		Sd = Sd + A(i)
		S(i) = Sn / Sd
	enddo
	t2 = omp_get_wtime()

	do i = 1, n
		print *, S(i)
	enddo
	deallocate(S, A)

	print *, "WITHOUT OMP:", t2 - t1
	!2.000.000: 0.47 -- 0.51
end program
