/*
 * Из презентации "Библиотека OpenMP"
 * Илья Кремер, Октябрь 2011
 *
 * http://kremer.pro/blog/?post_type=post&p=26
 *
 * $ gcc -fopenmp omp_factorial.c
 * $ ./a.out
 */

#include <stdio.h>
#include <omp.h>

int main() {
    int num_threads;
    int factorial, n;

    printf("Введите n: ");
    scanf ("%d", &n);
    printf("Количество нитей: ");
    scanf ("%d", &num_threads);

    omp_set_num_threads(num_threads);

    factorial = 1;
#pragma omp parallel
#pragma omp for reduction(* : factorial)
    for (int i = 2; i <= n; i++)
        factorial *= i;
    printf("%d\n", factorial);
}
