/*
 * Из презентации "Библиотека OpenMP"
 * Илья Кремер, Октябрь 2011
 *
 * http://kremer.pro/blog/?post_type=post&p=26
 *
 * $ gcc -fopenmp omp_matrix_multiplication.c
 * $ ./a.out
 */

#include <stdio.h>
#include <omp.h>
#include <stdlib.h>
#define N 400

int main() {
    double a[N][N], b[N][N], c[N][N];
    int i, j, k;
    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            a[i][j] = b[i][j] = (i + j);
    double t1 = omp_get_wtime();
#pragma omp parallel for shared(a, b, c) private(i, j, k)
    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++) {
            c[i][j] = 0;
            for (k = 0; k < N; k++)
                c[i][j] += a[i][k] * a[k][j];
        }
    printf("Прошло %lf сек\n", omp_get_wtime() - t1);
}
