/*
 * Из презентации "Библиотека OpenMP"
 * Илья Кремер, Октябрь 2011
 *
 * http://kremer.pro/blog/?post_type=post&p=26
 *
 * $ gcc -fopenmp omp_minimum.c
 * $ ./a.out
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <omp.h>

int main() {
    int th_num, num_threads;
    int *mins, minimum;
    const int N = 100;
    int numbers[N];

    srand(time(NULL));
    for (int i = 0; i < N; i++) {
        numbers[i] = rand() % 100;
        printf("%d\t", numbers[i]);
        if ((i + 1) % 10 == 0) printf("\n");
    }

    printf("\nКоличество нитей: ");
    scanf("%d", &num_threads);
    omp_set_num_threads(num_threads);
    mins = (int *) malloc(sizeof(int) * num_threads);

#pragma omp parallel private(th_num) shared(mins, numbers)
    {
        th_num = omp_get_thread_num();
        mins[th_num] = numbers[0];
#pragma omp for schedule(static, 1)
        for (int i = 1; i < N; i++) {
            if (numbers[i] < mins[th_num])
                mins[th_num] = numbers[i];
        }
        printf("Процесс #%d нашёл минимум: %d\n",
                th_num, mins[th_num]);
    } // конец параллельной области
    minimum = mins[0];
    for (int i = 1; i < num_threads; i++)
        if (mins[i] < minimum)
            minimum = mins[i];
    printf("Ответ: %d\n", minimum);
}